
        LEVEL = 0
Loop:   CLS
        GOSUB   GoLevel

        READ    COUNT       ' number of items in level

        PRINT AT 0, "Level "
        PRINT <> LEVEL
        PRINT " Count "
        PRINT <> COUNT

        FOR I = 1 to COUNT
            pos = 20 * I
            READ #data
            PRINT AT 20 * I, <.5>#data
        NEXT I

        PRINT AT 220, "Tap Controller"
        GOSUB WaitKey

        LEVEL = LEVEL + 1 - (6 AND (LEVEL = 5))
        GOTO Loop



WaitKey:Procedure
        WHILE (cont AND $FF) =  0 : WAIT : WEND
        WAIT
        WHILE (cont AND $FF) <> 0 : WAIT : WEND
        WAIT
        RETURN
        End


        ' Switch to the level number in LEVEL.
        ' Assume 2 levels per page.
GoLevel:Procedure
        POKE    $EFFF, $EA50 + (LEVEL / 2)  ' Page flip!
        ON LEVEL GOTO GoL0, GoL1, GoL2, GoL3, GoL4, GoL5

GoL0:   RESTORE Level0 : RETURN
GoL1:   RESTORE Level1 : RETURN
GoL2:   RESTORE Level2 : RETURN
GoL3:   RESTORE Level3 : RETURN
GoL4:   RESTORE Level4 : RETURN
GoL5:   RESTORE Level5 : RETURN
        End


        ' Sadly, this is needed to work around a bug in older versions 
        ' of jzIntv.

        ASM MACRO pad4k
        ASM   REPEAT (($1000 - $) AND $FFF)
        ASM     DECLE $FFFF
        ASM   ENDR
        ASM ENDM


        ASM ORG $E000:0 ; Levels 0 and 1

Level0: DATA    7, 0, 10, 20, 30, 40, 50, 60

Level1: DATA    5, 51, 41, 31, 21, 11

        ASM pad4k


        ASM ORG $E000:1 ; Levels 2 and 3

Level2: DATA    3, 112, 222, 332

Level3: DATA    4, 403, 413, 423, 433

        ASM pad4k


        ASM ORG $E000:2 ; Levels 4 and 5

Level4: DATA    10
        DATA    4001, 4002, 4003, 4004, 4005
        DATA    4006, 4007, 4008, 4009, 4010

Level5: DATA    5, 5, 55, 555, 5555, 55555

        ASM pad4k

        ASM ORG $F000   ; for epilogue code.
